﻿package  {
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.StageScaleMode;
	import flash.display.StageAlign;
	import flash.events.Event;
	import flash.events.DataEvent;
	import flash.events.MouseEvent;
	import flash.events.ProgressEvent;
	import flash.net.FileReference;
	import flash.net.FileReferenceList;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.URLRequestMethod;
	import flash.net.URLVariables;
	import flash.net.URLLoaderDataFormat;
	
	/**
	 * ...
	 * @author Pierrick Pluchon
	 */
	public class Main extends Sprite{

		//List of files 
		private var pendingFiles:Vector.<FileReference>;
		//List of unique filenames
		private var uniqueFileNames:Vector.<String>;
		private var myFileReferenceList:FileReferenceList;
		//clip with filename
		private var attachedFile:MovieClip;
		//
		private var attachedList:Vector.<MovieClip>;
		private var emailRequest:URLRequest;
		private var uploadRequest:URLRequest;
		private var variables:URLVariables;
		private var loader:URLLoader;
		//if there is somes files attached
		private var filesAttached:Boolean = false;
		// Boolean : if the form is ready to be send (ie: no files still being uploaded)
		private var readyToSend:Boolean = true;
		//Number of files currently uploaded
		private var nbFilesUploaded:uint = 0;
		private var nbCurrentFiles:uint;
		private var nbTotalFiles:uint;
		
		//Max size for uploading files
		// 2Mo is the standard limit on many hosters
		private const MAX_SIZE:uint = 2000 * 1024; 
		
		
		public function Main() {
			// constructor code
			if (stage) init();
			else this.addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void
		{
			if (e != null) this.removeEventListener(Event.ADDED_TO_STAGE, init);
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			uploadRequest = new URLRequest("php/upload.php");
			uploadRequest.method = URLRequestMethod.POST;
			myFileReferenceList = new FileReferenceList();
			// Set a vector of whole filereference objects
			pendingFiles = new Vector.<FileReference>();
			//Set a vector for whole files clip
			attachedList = new Vector.<MovieClip>();
			//Set a vector for whole unique file names (returned by PHP);
			uniqueFileNames = new Vector.<String>();
			initFormListeners();
			//Set the focus on the first field : subject
			stage.focus = subject;
		}
		
		private function initFormListeners():void
		{
			//Files manager events
			myFileReferenceList.addEventListener(Event.SELECT, onSelect);
			myFileReferenceList.addEventListener(Event.CANCEL, onCancel);
			//User Interface Events
			_send.buttonMode = true;
			_send.addEventListener(MouseEvent.CLICK, sendHandler);
			_attachement.buttonMode = true;
			_attachement.addEventListener(MouseEvent.CLICK, browseFiles);
		}
		
		private function browseFiles(e:MouseEvent):void
		{
			// Open the browse window
			myFileReferenceList.browse();
		}
		
		private function onSelect(e:Event):void
		{
			var file:FileReference;
			//Get the whole number of files
			nbTotalFiles = myFileReferenceList.fileList.length + nbCurrentFiles;
			for (var i:uint = 0; i < myFileReferenceList.fileList.length; i++) 
			{
				file = FileReference(myFileReferenceList.fileList[i]);
				attachedFile = new AttachedFile();
				this.addChild(attachedFile);
				attachedFile.x = _attachement.x;
				attachedFile.y = _attachement.y + _attachement.height + (attachedFile.height * nbCurrentFiles)
				attachedList.push(attachedFile);
				addPendingFile(file);
			}
		}
		
		private function addPendingFile(file:FileReference):void {
			nbCurrentFiles++;
			pendingFiles.push(file);
			if (file.size < MAX_SIZE)
			{
				//Set events for tracking upload
				file.addEventListener(Event.COMPLETE, completeHandler);
				file.addEventListener(ProgressEvent.PROGRESS, progressHandler);
				file.addEventListener ( DataEvent.UPLOAD_COMPLETE_DATA, onUploadComplete );
				//And then start upload
				file.upload(uploadRequest);
				readyToSend = false;
			} 
				else 
			{
				//Then the file is too big
				var id:uint = pendingFiles.indexOf(file);
				attachedList[id].filename.text = "File too big";
				//Since the las element is too big, remove it
				pendingFiles.pop();
				// And replace it by null
				pendingFiles.push(null);
				nbFilesUploaded++;
			}
		}
				
		private function progressHandler(e:ProgressEvent):void
		{
			//Get the id of the current FileRefence in pendingFiles
			var id:uint = pendingFiles.indexOf(e.currentTarget);
			var pct:uint = e.bytesLoaded * 100 / e.bytesTotal;
			attachedList[id].filename.text = "Uploading :" + String(pct)+"%";
		}
		
		//Execute when a file has been uploaded
		private function completeHandler(e:Event):void
		{
			
		}
		
		//Executes on server response after upload
		private function onUploadComplete(e:DataEvent):void
		{
			filesAttached = true;
			nbFilesUploaded++;
			if (nbFilesUploaded == nbTotalFiles)
			{
				readyToSend = true;
			}
			//Get the unique fileName returned by PHP
			var response:URLVariables = new URLVariables(e.data);
			var fileName:String = response.fileName;
			//Get the id of the current FileRefence in pendingFiles
			var id:uint = pendingFiles.indexOf(e.currentTarget);
			//The set the filename in the textfield
			attachedList[id].filename.text = fileName;
			uniqueFileNames.push(fileName);
		}
		
		private function onCancel(e:Event):void
		{
			
		}
		
		private function sendHandler(e:MouseEvent):void
		{
			if (isValidForm())
			{
				if (readyToSend)
				{
					//Set a new URLLoader 
					loader= new URLLoader();  
					emailRequest = new URLRequest("php/send.php");  
					// Set the method to POST (we will get these var with the $_POST  array in php
					emailRequest.method = URLRequestMethod.POST;
					variables = new URLVariables();  
					variables.email = email.text;  
					variables.message = message.text;  
					variables.subject = subject.text;
					for (var i:uint = 0; i < uniqueFileNames.length; i++)
					{
						//for every pendingFiles
						//set a new property to variables with the filename
						variables["myUploadedFile" + String(i)] = uniqueFileNames[i];
					}
					emailRequest.data = variables;
					loader.addEventListener(Event.COMPLETE, onResponse);
					loader.load(emailRequest);  
					
				} 
					else 
				{
					alert.text = "Files are still uploading";
				}
			} 
				else 
			{
				alert.text = "Please fill the form correctly";
			}
		}
		
		// On server response
		// Displays an alert depending on the server response
		private function onResponse(e:Event):void
		{
			if (e.target.data == "1") alert.text = "Your mail has been sent";
			else alert.text = "An error occured while sending your mail";
			resetForm();
		}
		
		//Simply resets the form and removes files name
		private function resetForm():void
		{
			subject.text="";
			message.text="";
			email.text="";
			//if(filesAttached)
			//{
				var i:uint=attachedList.length;
				while(i--)
				{
					this.removeChild(attachedList[i])
				}
			//}
		}
		
		// Check if all field are filled
		private function isValidForm():Boolean
		{
			if (subject.text!="" && message.text!="" && isValidEmail(email.text)==true) return true;
			else return false;
		}
		
		//Regexp for checking email
		function isValidEmail(email:String):Boolean {
			var emailExpression:RegExp = /^[a-z][\w.-]+@\w[\w.-]+\.[\w.-]*[a-z][a-z]$/i;
			return emailExpression.test(email);
		}


	}
	
}
